/************************************************************/

/** Sample program to control any Excel instance using DDE **/

/**        Copyright (C) RHA (Minisystems) Ltd 2001        **/

/** You may use this code in any way you wish, at your own **/
/** risk, provided credit is given.                        **/

/************************************************************/

#include <windows.h>
#include <ddeml.h>
#include <string.h>
#include <commctrl.h>
#include "ExcelDDE.h"

#define HIGH(a) (sizeof(a)/sizeof(a[0]))

LPSTR Commands[] = {
	"[OPEN(\"<Put the full file path here>\")]",
	"[SAVE.AS(\"<Put the file name here>\")]",
	"[SAVE.AS?(\"<Put the file name here>\")]",
	"[SELECT(\"<Put the range here>\")]",
	"[WORKBOOK.SELECT(\"<Put the sheet name in here>\")]",
	"[RUN(\"<Put your Macro name here>\")]",
	"[APP.ACTIVATE][ALERT(\"Hello from the sample Excel DDE driver\")]",
	"[APP.ACTIVATE]",
	"[APP.ACTIVATE][QUIT]"
};

HINSTANCE hInst;
HWND hwndEdit;
HWND hDialog = 0;
short SBheight;
HWND hStatusBar;
POINT OriginalSize;
POINT EditTopLeft;
int EditWidthAdjust;
int EditHeightAdjust;

/* Variables for sending data to Excel */

DWORD DDEInst = 0;
HSZ hszExcel;
HSZ hszTopic;
HSZ hszItem;
DWORD hTransaction = 0;
UINT LastTransType = 0;

HCONVLIST hConvList;
HCONV hConv = NULL;
CONVINFO cinfo;
UINT CSVformat;

char Message[100] = {0};
char TopicName[100] = {0};

HCURSOR hSaveCursor = 0;
HCURSOR hHourGlass = 0;

void SetOriginalRect( void );
void Connect( void );
void Disconnect( void );
void EnableControls( void );
void DoClientTransaction( UINT Transaction, LPSTR Data );
void FillWorksheetCombo( void );

HDDEDATA CALLBACK DdeCallback( UINT uType, UINT uFmt, HCONV hconv, HSZ hsz1,
							  HSZ hsz2, HDDEDATA hdata, DWORD dwData1, DWORD dwData2 );	

BOOL FAR PASCAL ExcelTestProc(
   HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );

/*********************************************************************/

int PASCAL WinMain(HINSTANCE hiCurrent, HINSTANCE hiPrevious,
   LPSTR lpszCmdLine, int nCmdShow )
{
	hInst = hiCurrent;

   DialogBox( hInst, "DLG_PORTTEST", NULL, ExcelTestProc );
   return 0;
}

/*********************************************************************/

BOOL FAR PASCAL ExcelTestProc(
   HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
   WORD NotifyCode = HIWORD(wParam);
   char Data[10000];
   RECT rc;
   DWORD Index;

   switch ( message )
   {
   case WM_INITDIALOG:

	   hDialog = hDlg;

	   hStatusBar = CreateStatusWindow( WS_CHILD | WS_VISIBLE | SBARS_SIZEGRIP,
		   "", hDlg, IDC_STATUS );
	   GetWindowRect( hStatusBar, &rc );
	   SBheight = (short)(rc.bottom - rc.top);
	   SendMessage( hStatusBar, SB_SETTEXT, 0, (LPARAM)(LPSTR) "No connection" );

	  /* Setup the DDEML instance */
	  DDEInst = 0;
	  DdeInitialize((LPDWORD) &DDEInst, (PFNCALLBACK) DdeCallback, APPCMD_CLIENTONLY, 0L);
	  hszExcel = DdeCreateStringHandle( DDEInst, "Excel", CP_WINANSI );
	  CheckDlgButton( hDlg, IDC_TEXT, 1 );
	  CSVformat = RegisterClipboardFormat( "CSV" );

	  SendDlgItemMessage( hDlg, IDC_INPUT, EM_SETLIMITTEXT, 0, 0 );

	  SendDlgItemMessage( hDialog, IDC_COMMAND, CB_RESETCONTENT, 0, 0 );
	  for ( Index = 0; Index < HIGH(Commands); Index++ )
		  SendDlgItemMessage( hDialog, IDC_COMMAND, CB_ADDSTRING, 0, (LPARAM)Commands[Index] );
	  SendDlgItemMessage( hDialog, IDC_COMMAND, CB_SETCURSEL, 0, 0 );

      SetOriginalRect();
	  EnableControls();
      return TRUE;

   case WM_GETMINMAXINFO:
      ((MINMAXINFO far *)lParam)->ptMinTrackSize = OriginalSize;
      return TRUE;

   case WM_SIZE:
      if ( wParam == SIZE_RESTORED || wParam == SIZE_MAXIMIZED )
      MoveWindow( hwndEdit, EditTopLeft.x, EditTopLeft.y,
                  LOWORD(lParam) - EditWidthAdjust,
                  HIWORD(lParam) - EditHeightAdjust, TRUE );
	  SendMessage( hStatusBar, WM_SIZE, 0, 0 );
      return FALSE;

   case WM_COMMAND:

      switch ( LOWORD(wParam) )
      {
	  case IDC_LAUNCH:
		  ShellExecute( hDlg, NULL, "excel.exe", "", "", SW_SHOW );
		  return TRUE;

	  case IDC_CONNECT:
		  Connect();
		  return TRUE;

	  case IDC_DISCONNECT:
		  Disconnect();
		  return TRUE;

	  case IDC_FINDWORKSHEETS:
		  FillWorksheetCombo();
		  return TRUE;

	  case IDC_REQUEST:
		  DoClientTransaction( XTYP_REQUEST, 0 );
		  return TRUE;

	  case IDC_POKE:
		  GetDlgItemText(hDlg, IDC_INPUT, Data, sizeof(Data) );
		  DoClientTransaction( XTYP_POKE, (LPSTR) Data );
		  return TRUE;

	  case IDC_EXECUTE:
		  GetDlgItemText(hDlg, IDC_COMMAND, Data, sizeof(Data) );
		  DoClientTransaction( XTYP_EXECUTE, Data );
		  return TRUE;

	  case IDC_ADDTOLIST:
		  GetDlgItemText(hDlg, IDC_COMMAND, Data, sizeof(Data) );
		  SendDlgItemMessage( hDialog, IDC_COMMAND, CB_ADDSTRING, 0,
			  (LPARAM)(LPSTR) Data );
		  return TRUE;

	  case IDOK:
      case IDCANCEL:
		  Disconnect();
		  DdeFreeStringHandle( DDEInst, hszExcel );
		  DdeUninitialize( DDEInst );
		  DDEInst = 0;
		  EndDialog( hDlg, 0 );
         return TRUE;

      default:
         break;
      }
      return FALSE;

   default:
      return FALSE;
   }

   return FALSE;
}

/*****************************************************************/

HDDEDATA CALLBACK DdeCallback( UINT uType, UINT uFmt, HCONV hconv, HSZ hsz1,
							  HSZ hsz2, HDDEDATA hdata, DWORD dwData1, DWORD dwData2 )
{
	LPBYTE pData;

	switch ( uType )
	{
	case XTYP_XACT_COMPLETE:
		if ( dwData1 != hTransaction ) return 0;

		if ( !hdata )
			SendMessage( hStatusBar, SB_SETTEXT, 0, (LPARAM)(LPSTR)"Transaction failed" );
		else if ( LastTransType == XTYP_REQUEST )
		{
			pData = DdeAccessData( hdata, 0 );
			if ( pData )
			{
				SetDlgItemText( hDialog, IDC_INPUT, pData );
				DdeUnaccessData( hdata );
				SendMessage( hStatusBar, SB_SETTEXT, 0, (LPARAM)(LPSTR)"Request succeeded" );
			}
			else
				SendMessage( hStatusBar, SB_SETTEXT, 0, (LPARAM)(LPSTR)"No data was returned" );
		}
		else
			SendMessage( hStatusBar, SB_SETTEXT, 0, (LPARAM)(LPSTR)"Transaction succeeded" );

		hTransaction = 0;
		return 0;

	case XTYP_DISCONNECT:
		hTransaction = 0;
		Disconnect();
		SendMessage( hStatusBar, SB_SETTEXT, 0, (LPARAM)(LPSTR)"Excel terminated the conversation" );
		return 0;

	default:
		return 0;
	}
}

/*****************************************************************/

void DoClientTransaction( UINT Transaction, LPSTR Data )
{
	char Temp[1000];
	HSZ hszItem;
	UINT Format;
	UINT DataLen = 0;

	if ( hTransaction ) DdeAbandonTransaction( DDEInst, hConv, hTransaction );

	if ( Data ) DataLen = strlen(Data) + 1;

	if ( Transaction == XTYP_EXECUTE )
	{
		Format = 0;
		hszItem = 0;
	}
	else
	{
		GetDlgItemText(hDialog, IDC_ITEM, Temp, sizeof(Temp) );
		hszItem = DdeCreateStringHandle( DDEInst, Temp, CP_WINANSI );
		if ( IsDlgButtonChecked( hDialog, IDC_TEXT ) )
			Format = CF_TEXT;
		else
			Format = CSVformat;
	}
	
	if (  !DdeClientTransaction( Data, DataLen, hConv, hszItem, Format,
		Transaction, TIMEOUT_ASYNC, &hTransaction ) )
	{
		SendMessage( hStatusBar, SB_SETTEXT, 0, (LPARAM)(LPSTR)"Transaction not accepted" );
		hTransaction = 0;
	}
	LastTransType = Transaction;
	DdeFreeStringHandle( DDEInst, hszItem );
}

/*****************************************************************/

void SetOriginalRect( void )
{
   RECT rDlg;
   RECT rEdit;
   POINT ClientTopLeft = {0, 0};

   hwndEdit = GetDlgItem( hDialog, IDC_INPUT );

   /* Get the original window rectangle for MINMAXINFO */
   GetWindowRect( hDialog, &rDlg );
   OriginalSize.x = rDlg.right - rDlg.left;
   OriginalSize.y = rDlg.bottom - rDlg.top;

   /* Get the offset to subtract from dlg size for edit box size */
   GetWindowRect( hwndEdit, &rEdit );
   GetClientRect( hDialog, &rDlg );
   EditWidthAdjust = rDlg.right - (rEdit.right-rEdit.left);
   EditHeightAdjust = rDlg.bottom - (rEdit.bottom-rEdit.top);

   /* Get the client top left in screen coordinates */
   ClientToScreen( hDialog, &ClientTopLeft );

   /* Get the edit rectangle to get its position within the client */
   EditTopLeft.x = rEdit.left - ClientTopLeft.x;
   EditTopLeft.y = rEdit.top - ClientTopLeft.y;
}

/*********************************************************************/

void FillWorksheetCombo( void )
{
	HWND hWndCombo = GetDlgItem( hDialog, IDC_SHEETNAMES );
	char SheetName[50];
	DWORD SheetCount = 0;
	HCONV hConvLocal = 0;

	SendMessage( hWndCombo, CB_RESETCONTENT, 0, 0 );

    /* This may take a little while */
	hHourGlass = LoadCursor( NULL, IDC_WAIT );
    hSaveCursor = SetCursor( hHourGlass );

    hConvList = DdeConnectList( DDEInst, hszExcel, NULL, NULL, NULL);

    if( hConvList )
    {
		hConvLocal = 0;
        cinfo.cb = sizeof(CONVINFO);

        while ( hConvLocal = DdeQueryNextServer(hConvList, hConvLocal) )
		{
			(void) DdeQueryConvInfo( hConvLocal, (DWORD) QID_SYNC, &cinfo );
            DdeQueryString( DDEInst, cinfo.hszTopic, SheetName, sizeof(SheetName), CP_WINANSI );
			SendMessage( hWndCombo, CB_ADDSTRING, 0, (LPARAM) SheetName );
		}
        DdeDisconnectList( hConvList );
	}

	(void) SetCursor( hSaveCursor );

	/* Check that there are some spreadsheets open, fail if not */
	SheetCount = SendMessage(hWndCombo, CB_GETCOUNT, 0, 0);
	if ( SheetCount != 0 )
		SendMessage( hWndCombo, CB_SETCURSEL, 0, 0 );

	EnableControls();
}

/*********************************************************************/

void Disconnect( void )
{
	if ( !hConv ) return;

	if ( hTransaction ) DdeAbandonTransaction( DDEInst, hConv, hTransaction );
	hTransaction = 0;
	DdeDisconnect( hConv );
	hConv = 0;
	EnableControls();
}

/*********************************************************************/

void Connect( void )
{
	if ( hConv ) return;

	Disconnect();
	GetDlgItemText(hDialog, IDC_SHEETNAMES, TopicName, sizeof(TopicName) );
	hszTopic = DdeCreateStringHandle( DDEInst, TopicName, CP_WINANSI );
	hConv = DdeConnect( DDEInst, hszExcel, hszTopic, NULL );
	DdeFreeStringHandle( DDEInst, hszTopic );
	EnableControls();
}

/*********************************************************************/

void EnableControls( void )
{
	char Temp[1000];

	GetDlgItemText(hDialog, IDC_SHEETNAMES, TopicName, sizeof(TopicName) );
	EnableWindow( GetDlgItem(hDialog, IDC_CONNECT), (!hConv) && (TopicName[0] != 0) );
	EnableWindow( GetDlgItem(hDialog, IDC_DISCONNECT), hConv != 0 );
	EnableWindow( GetDlgItem(hDialog, IDC_EXECUTE), hConv != 0 );
	EnableWindow( GetDlgItem(hDialog, IDC_POKE), hConv != 0 );
	EnableWindow( GetDlgItem(hDialog, IDC_REQUEST), hConv != 0 );

	if ( hConv )
	{
		wsprintf( Temp, "Connected to Excel|%s", (LPSTR)TopicName );
		SendMessage( hStatusBar, SB_SETTEXT, 0, (LPARAM)(LPSTR) Temp );
	}
	else
		SendMessage( hStatusBar, SB_SETTEXT, 0, (LPARAM)(LPSTR) "No connection" );
}
